/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Original Code is DigitalSesame
 * Portions created by DigitalSesame are Copyright (C) 1997-2000 DigitalSesame
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: Test.java,v 1.1.1.1 2003/03/10 16:36:09 taweili Exp $
 */

package tests.org.enhydra.wireless.voicexml;

import org.w3c.dom.Element;
import java.io.File;
import java.io.IOException;
import java.io.FileOutputStream;
import org.enhydra.xml.xmlc.XMLObject;
import org.enhydra.xml.io.DOMFormatter;
import org.enhydra.xml.io.OutputOptions;
import org.enhydra.xml.dom.DOMInfo;

/**
 * Very simple test of VoiceXML and XMLC functionality.
 */
public class Test {
    private static final String OUT_DIR = "output";
    private static void output(XMLObject doc,
                               String outname) throws IOException {
        OutputOptions oos = new OutputOptions();
        oos.setOmitEncoding(true);
        oos.setJavaEncoding("ASCII");
        DOMFormatter domf = new DOMFormatter(oos);
        File ofile = new File(OUT_DIR, outname + ".vxml");
        FileOutputStream ostream = new FileOutputStream(ofile);
        domf.write(doc, ostream);
        ostream.close();

        ofile = new File(OUT_DIR, outname + ".dom");
        ostream = new FileOutputStream(ofile);
        DOMInfo.printTree(doc.getClass().getName(), doc, ostream);
        ostream.close();
    }

    public static void main(String args[]) throws IOException {
        Element elem;

        Test1VoiceXML1VoiceXML test1VoiceXML1
            = new Test1VoiceXML1VoiceXML();
        elem = test1VoiceXML1.getElementForm1();
        output(test1VoiceXML1, "test1VoiceXML1");

        Test1EnhydraNuanceVoiceXML1VoiceXML test1EnhydraNuanceVoiceXML1
            = new Test1EnhydraNuanceVoiceXML1VoiceXML();
        elem = test1EnhydraNuanceVoiceXML1.getElementTime();
        test1EnhydraNuanceVoiceXML1.setTextTime("12:12:12");
        output(test1EnhydraNuanceVoiceXML1, "test1EnhydraNuanceVoiceXML1");

        Test1EnhydraVoiceXML1VoiceXML test1EnhydraVoiceXML1
            = new Test1EnhydraVoiceXML1VoiceXML();
        elem = test1EnhydraVoiceXML1.getElementTime();
        test1EnhydraVoiceXML1.setTextTime("12:12:12");
        output(test1EnhydraVoiceXML1, "test1EnhydraVoiceXML1");

        Test1NuanceVoiceXML1VoiceXML test1NuanceVoiceXML1
            = new Test1NuanceVoiceXML1VoiceXML();
        output(test1NuanceVoiceXML1, "test1NuanceVoiceXML1");

        Test1TellMeVoiceXML test1TellMeVoiceXML
            = new Test1TellMeVoiceXML();
        output(test1TellMeVoiceXML, "test1TellMeVoiceXML");

        Test2EnhydraNuanceVoiceXML1VoiceXML test2EnhydraNuanceVoiceXML1
            = new Test2EnhydraNuanceVoiceXML1VoiceXML();
        elem = test2EnhydraNuanceVoiceXML1.getElementTime();
        test2EnhydraNuanceVoiceXML1.setTextTime("12:12:12");
        output(test2EnhydraNuanceVoiceXML1, "test2EnhydraNuanceVoiceXML1");

        Test2EnhydraVoiceXML1VoiceXML test2EnhydraVoiceXML1
            = new Test2EnhydraVoiceXML1VoiceXML();
        elem = test2EnhydraVoiceXML1.getElementTime();
        test2EnhydraVoiceXML1.setTextTime("12:12:12");
        output( test2EnhydraVoiceXML1, "test2EnhydraVoiceXML1");

        Test2NuanceVoiceXML1VoiceXML test2NuanceVoiceXML1
            = new Test2NuanceVoiceXML1VoiceXML();
        output(test2NuanceVoiceXML1, "test2NuanceVoiceXML1");

        Test2TellMeVoiceXML test2TellMeVoiceXML
            = new Test2TellMeVoiceXML();
        output(test2TellMeVoiceXML, "test2TellMeVoiceXML");
    }
}

