package org.enhydra.xml.xmlc.deferredparsing;



import org.apache.bcel.generic.*;

import org.apache.bcel.classfile.*;

import org.apache.bcel.*;

import java.io.*;



public class DynamicMLCreator implements Constants {

    private String             className;

    private String             sourcePath;

    private InstructionFactory _factory;

    private ConstantPoolGen   _cp;

    private ClassGen          _cg;

    private String            _impl;



    public DynamicMLCreator(String name, String path) {

	className = name;

	sourcePath = path;

	

	String type = (path.endsWith(".html") || path.endsWith(".htm") || path.endsWith(".xhtml") || path.endsWith(".chtml")) ? "html" : "xml";

	if (type.equals("html")) {

	        //xhtml is actually xml, but generated xhtml classes look like

	        //this rather than the xml below, so including xhtml for this

	        //definition

	        _impl = "org.enhydra.xml.xmlc.html.HTMLObjectImpl";

        	_cg = new ClassGen(className,

        			   _impl, 

        			   "<generated>", 

        			   ACC_PUBLIC | ACC_SUPER, 

        			   new String[] { "org.enhydra.xml.xmlc.XMLObject", 

        					  "org.enhydra.xml.xmlc.html.HTMLObject" });

        } else {

                _impl = "org.enhydra.xml.xmlc.XMLObjectImpl";

        	_cg = new ClassGen(className,

        			   _impl, 

        			   "<generated>", 

        			   ACC_PUBLIC | ACC_SUPER, 

        			   new String[] { "org.enhydra.xml.xmlc.XMLObject" });

        }

	

	_cp = _cg.getConstantPool();

	_factory = new InstructionFactory(_cg, _cp);

    }



    public JavaClass create() {

	createFields();

	createMethod_0();

	createMethod_1();

	createMethod_2();

	createMethod_3();

	createMethod_4();

	createMethod_5();

	createMethod_6();

	createMethod_7();

	createMethod_8();

	createMethod_9();

	createMethod_10();

	//createMethod_11();

	return _cg.getJavaClass();

    }



    private void createFields() {

	FieldGen field;



	field = new FieldGen(ACC_PUBLIC | ACC_STATIC | ACC_FINAL, new ObjectType("java.lang.Class"), "XMLC_GENERATED_CLASS", _cp);

	_cg.addField(field.getField());



	field = new FieldGen(ACC_PUBLIC | ACC_STATIC | ACC_FINAL, Type.STRING, "XMLC_SOURCE_FILE", _cp);

	field.setInitValue(sourcePath);

	_cg.addField(field.getField());



	field = new FieldGen(ACC_PRIVATE | ACC_STATIC | ACC_FINAL, new ObjectType("org.enhydra.xml.xmlc.dom.XMLCDomFactory"), "fDOMFactory", _cp);

	_cg.addField(field.getField());



	field = new FieldGen(ACC_PRIVATE | ACC_FINAL, new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), "fDocumentLoader", _cp);

	_cg.addField(field.getField());



	field = new FieldGen(ACC_PRIVATE | ACC_STATIC, new ObjectType("java.lang.Class"), "class$L" + className.replace('.', '$'), _cp);

	_cg.addField(field.getField());



	/*field = new FieldGen(ACC_PRIVATE | ACC_STATIC, new ObjectType("java.lang.Class"), "class$Lorg$enhydra$xml$xmlc$dom$lazydom$LazyHTMLDomFactory", _cp);

	_cg.addField(field.getField());*/

    }



    private void createMethod_0() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, Type.NO_ARGS, new String[] {  }, 

					 "buildDocument", 

					 className,

					 il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(className,

					"getDocumentLoader", 

					new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("java.lang.Object", "getClass", new ObjectType("java.lang.Class"), Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader", "getDocument", new ObjectType("org.w3c.dom.Document"), new Type[] { new ObjectType("java.lang.Class") }, Constants.INVOKEINTERFACE));

	il.append(new PUSH(_cp, "text/html"));

	il.append(new PUSH(_cp, "UTF8"));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "setDocument", Type.VOID, new Type[] { new ObjectType("org.w3c.dom.Document"), Type.STRING, Type.STRING }, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_21 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "syncAccessMethods", Type.VOID, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_25 = il.append(_factory.createReturn(Type.VOID));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_1() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC,

					 new ObjectType("org.w3c.dom.Node"),

					 new Type[] { Type.BOOLEAN },

					 new String[] { "arg0" },

					 "cloneNode",

					 className, 

					 il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.INT, 1));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "cloneDeepCheck", Type.VOID, new Type[] { Type.BOOLEAN }, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_5 = il.append(_factory.createNew(className));

	il.append(InstructionConstants.DUP);

	il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(className,

					"<init>", 

					Type.VOID, 

					new Type[] { new ObjectType(className) }, 

					Constants.INVOKESPECIAL));

	InstructionHandle ih_13 = il.append(_factory.createReturn(Type.OBJECT));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_2() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PROTECTED | ACC_FINAL, new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.NO_ARGS, new String[] {  }, "getDocumentLoader", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createFieldAccess(className, "fDocumentLoader", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Constants.GETFIELD));

	InstructionHandle ih_4 = il.append(_factory.createReturn(Type.OBJECT));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_3() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PROTECTED | ACC_FINAL, new ObjectType("org.enhydra.xml.xmlc.dom.XMLCDomFactory"), Type.NO_ARGS, new String[] {  }, "getDomFactory", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createFieldAccess(className, "fDOMFactory", new ObjectType("org.enhydra.xml.xmlc.dom.XMLCDomFactory"), Constants.GETSTATIC));

	InstructionHandle ih_3 = il.append(_factory.createReturn(Type.OBJECT));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_4() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PROTECTED, Type.VOID, new Type[] { new ObjectType("org.w3c.dom.Node") }, new String[] { "arg0" }, "syncWithDocument", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(new INSTANCEOF(_cp.addClass(new ObjectType("org.w3c.dom.Element"))));

        BranchInstruction ifeq_4 = _factory.createBranchInstruction(Constants.IFEQ, null);

	il.append(ifeq_4);

	InstructionHandle ih_7 = il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createCheckCast(new ObjectType("org.w3c.dom.Element")));

	il.append(new PUSH(_cp, "id"));

	il.append(_factory.createInvoke("org.w3c.dom.Element", "getAttribute", Type.STRING, new Type[] { Type.STRING }, Constants.INVOKEINTERFACE));

	il.append(_factory.createStore(Type.OBJECT, 2));

	InstructionHandle ih_19 = il.append(_factory.createLoad(Type.OBJECT, 2));

	il.append(_factory.createInvoke("java.lang.String", "length", Type.INT, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

        BranchInstruction ifne_23 = _factory.createBranchInstruction(Constants.IFNE, null);

	il.append(ifne_23);

	InstructionHandle ih_26 = il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke("org.w3c.dom.Node", "getFirstChild", new ObjectType("org.w3c.dom.Node"), Type.NO_ARGS, Constants.INVOKEINTERFACE));

	il.append(_factory.createStore(Type.OBJECT, 2));

	InstructionHandle ih_33;

	BranchInstruction goto_33 = _factory.createBranchInstruction(Constants.GOTO, null);

	ih_33 = il.append(goto_33);

	InstructionHandle ih_36 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 2));

	il.append(_factory.createInvoke(className, "syncWithDocument", Type.VOID, new Type[] { new ObjectType("org.w3c.dom.Node") }, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_41 = il.append(_factory.createLoad(Type.OBJECT, 2));

	il.append(_factory.createInvoke("org.w3c.dom.Node", "getNextSibling", new ObjectType("org.w3c.dom.Node"), Type.NO_ARGS, Constants.INVOKEINTERFACE));

	il.append(_factory.createStore(Type.OBJECT, 2));

	InstructionHandle ih_48 = il.append(_factory.createLoad(Type.OBJECT, 2));

        BranchInstruction ifnonnull_49 = _factory.createBranchInstruction(Constants.IFNONNULL, ih_36);

	il.append(ifnonnull_49);

	InstructionHandle ih_52 = il.append(_factory.createReturn(Type.VOID));

	ifeq_4.setTarget(ih_26);

	ifne_23.setTarget(ih_26);

	goto_33.setTarget(ih_48);

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_5() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_STATIC, new ObjectType("java.lang.Class"), new Type[] { Type.STRING }, new String[] { "arg0" }, "class$", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("java.lang.Class", "forName", new ObjectType("java.lang.Class"), new Type[] { Type.STRING }, Constants.INVOKESTATIC));

	InstructionHandle ih_4 = il.append(_factory.createReturn(Type.OBJECT));

	InstructionHandle ih_5 = il.append(_factory.createStore(Type.OBJECT, 1));

	il.append(_factory.createNew("java.lang.NoClassDefFoundError"));

	il.append(InstructionConstants.DUP);

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke("java.lang.Throwable", "getMessage", Type.STRING, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createInvoke("java.lang.NoClassDefFoundError", "<init>", Type.VOID, new Type[] { Type.STRING }, Constants.INVOKESPECIAL));

	InstructionHandle ih_17 = il.append(InstructionConstants.ATHROW);

	method.addExceptionHandler(ih_0, ih_4, ih_5, new ObjectType("java.lang.ClassNotFoundException"));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_6() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, Type.NO_ARGS, new String[] {  }, "<init>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.deferredparsing.StandardDocumentLoader", "getInstance", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.NO_ARGS, Constants.INVOKESTATIC));

	il.append(_factory.createInvoke(className, "<init>", Type.VOID, new Type[] { new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader") }, Constants.INVOKESPECIAL));

	InstructionHandle ih_7 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(className, "buildDocument", Type.VOID, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_11 = il.append(_factory.createReturn(Type.VOID));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_7() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, new Type[] { Type.BOOLEAN }, new String[] { "arg0" }, "<init>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.deferredparsing.StandardDocumentLoader", "getInstance", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.NO_ARGS, Constants.INVOKESTATIC));

	il.append(_factory.createLoad(Type.INT, 1));

	il.append(_factory.createInvoke(className, "<init>", Type.VOID, new Type[] { new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.BOOLEAN }, Constants.INVOKESPECIAL));

	InstructionHandle ih_8 = il.append(_factory.createReturn(Type.VOID));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_8() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, new Type[] { new ObjectType(className) }, new String[] { "arg0" }, "<init>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(_impl, "<init>", Type.VOID, Type.NO_ARGS, Constants.INVOKESPECIAL));

	InstructionHandle ih_4 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke(className, "getDocumentLoader", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createFieldAccess(className, "fDocumentLoader", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Constants.PUTFIELD));

	InstructionHandle ih_12 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "getDocument", new ObjectType("org.w3c.dom.Document"), Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(new PUSH(_cp, 1));

	il.append(_factory.createInvoke("org.w3c.dom.Node", "cloneNode", new ObjectType("org.w3c.dom.Node"), new Type[] { Type.BOOLEAN }, Constants.INVOKEINTERFACE));

	il.append(_factory.createCheckCast(new ObjectType("org.w3c.dom.Document")));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "getMIMEType", Type.STRING, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "getEncoding", Type.STRING, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "setDocument", Type.VOID, new Type[] { new ObjectType("org.w3c.dom.Document"), Type.STRING, Type.STRING }, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_37 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke("org.enhydra.xml.xmlc.XMLObjectImpl", "syncAccessMethods", Type.VOID, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_41 = il.append(_factory.createReturn(Type.VOID));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_9() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, new Type[] { new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.BOOLEAN }, new String[] { "arg0", "arg1" }, "<init>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(_impl, "<init>", Type.VOID, Type.NO_ARGS, Constants.INVOKESPECIAL));

	InstructionHandle ih_4 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(_factory.createFieldAccess(className, "fDocumentLoader", new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Constants.PUTFIELD));

	InstructionHandle ih_9 = il.append(_factory.createLoad(Type.INT, 2));

        BranchInstruction ifeq_10 = _factory.createBranchInstruction(Constants.IFEQ, null);

	il.append(ifeq_10);

	InstructionHandle ih_13 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createInvoke(className, "buildDocument", Type.VOID, Type.NO_ARGS, Constants.INVOKEVIRTUAL));

	InstructionHandle ih_17 = il.append(_factory.createReturn(Type.VOID));

	ifeq_10.setTarget(ih_17);

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_10() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_PUBLIC, Type.VOID, new Type[] { new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader") }, new String[] { "arg0" }, "<init>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createLoad(Type.OBJECT, 0));

	il.append(_factory.createLoad(Type.OBJECT, 1));

	il.append(new PUSH(_cp, 1));

	il.append(_factory.createInvoke(className, "<init>", Type.VOID, new Type[] { new ObjectType("org.enhydra.xml.xmlc.deferredparsing.DocumentLoader"), Type.BOOLEAN }, Constants.INVOKESPECIAL));

	InstructionHandle ih_6 = il.append(_factory.createReturn(Type.VOID));

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



    private void createMethod_11() {

	InstructionList il = new InstructionList();

	MethodGen method = new MethodGen(ACC_STATIC | ACC_FINAL, Type.VOID, Type.NO_ARGS, new String[] {  }, "<clinit>", className, il, _cp);



	InstructionHandle ih_0 = il.append(_factory.createFieldAccess(className, "class$L" + className.replace('.','$'), new ObjectType("java.lang.Class"), Constants.GETSTATIC));

        BranchInstruction ifnull_3 = _factory.createBranchInstruction(Constants.IFNULL, null);

	il.append(ifnull_3);

	il.append(_factory.createFieldAccess(className, 

					     "class$L" + className.replace('.','$'), 

					     new ObjectType("java.lang.Class"), Constants.GETSTATIC));

        BranchInstruction goto_9 = _factory.createBranchInstruction(Constants.GOTO, null);

	il.append(goto_9);

	InstructionHandle ih_12 = il.append(new PUSH(_cp, className));

	il.append(_factory.createInvoke(className, "class$", new ObjectType("java.lang.Class"), new Type[] { Type.STRING }, Constants.INVOKESTATIC));

	il.append(InstructionConstants.DUP);

	il.append(_factory.createFieldAccess(className, 

					     "class$L" + className.replace('.','$'),

					     new ObjectType("java.lang.Class"), Constants.PUTSTATIC));

	InstructionHandle ih_21 = il.append(_factory.createFieldAccess(className, "XMLC_GENERATED_CLASS", new ObjectType("java.lang.Class"), Constants.PUTSTATIC));

	InstructionHandle ih_24 = il.append(_factory.createFieldAccess(className, "class$Lorg$enhydra$xml$xmlc$dom$lazydom$LazyHTMLDomFactory", new ObjectType("java.lang.Class"), Constants.GETSTATIC));

        BranchInstruction ifnull_27 = _factory.createBranchInstruction(Constants.IFNULL, null);

	il.append(ifnull_27);

	il.append(_factory.createFieldAccess(className, "class$Lorg$enhydra$xml$xmlc$dom$lazydom$LazyHTMLDomFactory", new ObjectType("java.lang.Class"), Constants.GETSTATIC));

        BranchInstruction goto_33 = _factory.createBranchInstruction(Constants.GOTO, null);

	il.append(goto_33);

	InstructionHandle ih_36 = il.append(new PUSH(_cp, "org.enhydra.xml.xmlc.dom.lazydom.LazyHTMLDomFactory"));

	il.append(_factory.createInvoke(className, "class$", new ObjectType("java.lang.Class"), new Type[] { Type.STRING }, Constants.INVOKESTATIC));

	il.append(InstructionConstants.DUP);

	il.append(_factory.createFieldAccess(className, "class$Lorg$enhydra$xml$xmlc$dom$lazydom$LazyHTMLDomFactory", new ObjectType("java.lang.Class"), Constants.PUTSTATIC));

	InstructionHandle ih_45 = il.append(_factory.createInvoke("org.enhydra.xml.xmlc.dom.XMLCDomFactoryCache", "getFactory", new ObjectType("org.enhydra.xml.xmlc.dom.XMLCDomFactory"), new Type[] { new ObjectType("java.lang.Class") }, Constants.INVOKESTATIC));

	il.append(_factory.createFieldAccess(className, "fDOMFactory", new ObjectType("org.enhydra.xml.xmlc.dom.XMLCDomFactory"), Constants.PUTSTATIC));

	il.append(_factory.createReturn(Type.VOID));

	ifnull_3.setTarget(ih_12);

	goto_9.setTarget(ih_21);

	ifnull_27.setTarget(ih_36);

	goto_33.setTarget(ih_45);

	method.setMaxStack();

	method.setMaxLocals();

	_cg.addMethod(method.getMethod());

	il.dispose();

    }



}

