/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: HTMLTagSetType.java,v 1.1.1.1 2003/03/10 16:36:23 taweili Exp $
 */

package org.enhydra.xml.xmlc.metadata;

/**
 * Enumerated type for the parser XMLC will use.
 */
public class HTMLTagSetType extends EnumeratedType {
    /**
     * Constant for cyberstubio
     */
    public static final HTMLTagSetType CYBERSTUDIO = new HTMLTagSetType("cyberstudio");

    /**
     * Internal constructor.  Only a fixed set of types are allowed.
     */
    private HTMLTagSetType(String name) {
        super(name);
    }

    /**
     * Get the object for the specified type.  If desiredType is null,
     * return null.
     */
    public static HTMLTagSetType getType(String desiredType) {
        if (desiredType == null) {
            return null;
        } else if (CYBERSTUDIO.fName.equals(desiredType)) {
            return CYBERSTUDIO;
        } else {
            throw new IllegalArgumentException("Invalid HTMLTagSetType: \""
                                               + desiredType
                                               + "\", expected \""
                                               + CYBERSTUDIO.fName
                                               + "\"");
        }
    }
}
