/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: TestException.java,v 1.1.1.1 2003/03/10 16:36:25 taweili Exp $
 */

package org.enhydra.xml.driver;

import org.enhydra.error.ChainedRuntimeException;

/**
 * Runtime exception used to report errors during a test.
 */
public class TestException extends ChainedRuntimeException {
    /**
     * @see ChainedException#ChainedException(String)
     */
    public TestException(String msg) {
        super(msg);
    }
    
    /**
     * @see ChainedException#ChainedException(String, Throwable)
     */
    public TestException(String msg,
                         Throwable cause) {
        super(msg, cause);
    }
    
    /**
     * @see ChainedException#ChainedException(Throwable)
     */
    public TestException(Throwable cause) {
        super(cause);
    }
}
