/*
 * Enhydra Java Application Server Project
 * 
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See 
 * the License for the specific terms governing rights and limitations
 * under the License.
 * 
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 * 
 * Contributor(s):
 * 
 * $Id: DOMEditor.java,v 1.1.1.1 2003/03/10 16:37:11 taweili Exp $
 */

package org.enhydra.xml.xmlc.perf;

import org.w3c.dom.*;;

/**
 * Interface for editing a DOM.
 */
public interface DOMEditor {

    /**
     * Edits a DOM tree.
     *
     * @return the number of elements edited.
     */
    public int edit(Document doc) throws Exception;

    /**
     * The edit function can be called as long as this method returns true.
     * The editor may contain multiple configurations, this method cycles
     * through each configuration.
     *
     * @return true if there is another editor configuration that should be run.
     */
    public boolean next();

    /**
     * Reset the editor configuration queue.
     */
    public void reset();
}






